summaryrefslogtreecommitdiffstats
path: root/modules.d/04watchdog
diff options
context:
space:
mode:
Diffstat (limited to 'modules.d/04watchdog')
-rwxr-xr-xmodules.d/04watchdog/module-setup.sh34
-rwxr-xr-xmodules.d/04watchdog/watchdog-stop.sh2
-rwxr-xr-xmodules.d/04watchdog/watchdog.sh12
3 files changed, 48 insertions, 0 deletions
diff --git a/modules.d/04watchdog/module-setup.sh b/modules.d/04watchdog/module-setup.sh
new file mode 100755
index 0000000..e9ce878
--- /dev/null
+++ b/modules.d/04watchdog/module-setup.sh
@@ -0,0 +1,34 @@
+#!/bin/bash
+
+# called by dracut
+check() {
+ return 255
+}
+
+# called by dracut
+depends() {
+ echo watchdog-modules
+ return 0
+}
+
+# called by dracut
+install() {
+ # Do not add watchdog hooks if systemd module is included
+ # In that case, systemd will manage watchdog kick
+ if ! dracut_module_included "systemd"; then
+ inst_hook cmdline 00 "$moddir/watchdog.sh"
+ inst_hook cmdline 50 "$moddir/watchdog.sh"
+ inst_hook pre-trigger 00 "$moddir/watchdog.sh"
+ inst_hook initqueue 00 "$moddir/watchdog.sh"
+ inst_hook mount 00 "$moddir/watchdog.sh"
+ inst_hook mount 50 "$moddir/watchdog.sh"
+ inst_hook mount 99 "$moddir/watchdog.sh"
+ inst_hook pre-pivot 00 "$moddir/watchdog.sh"
+ inst_hook pre-pivot 99 "$moddir/watchdog.sh"
+ inst_hook cleanup 00 "$moddir/watchdog.sh"
+ inst_hook cleanup 99 "$moddir/watchdog.sh"
+ fi
+
+ inst_hook emergency 02 "$moddir/watchdog-stop.sh"
+ inst_multiple -o wdctl
+}
diff --git a/modules.d/04watchdog/watchdog-stop.sh b/modules.d/04watchdog/watchdog-stop.sh
new file mode 100755
index 0000000..921f969
--- /dev/null
+++ b/modules.d/04watchdog/watchdog-stop.sh
@@ -0,0 +1,2 @@
+#!/bin/sh
+[ -c /dev/watchdog ] && printf 'V' > /dev/watchdog
diff --git a/modules.d/04watchdog/watchdog.sh b/modules.d/04watchdog/watchdog.sh
new file mode 100755
index 0000000..22919ee
--- /dev/null
+++ b/modules.d/04watchdog/watchdog.sh
@@ -0,0 +1,12 @@
+#!/bin/sh
+if [ -e /dev/watchdog ]; then
+ if [ ! -e /tmp/watchdog_timeout ]; then
+ wdctl -s 60 /dev/watchdog > /dev/null 2>&1
+ : > /tmp/watchdog_timeout
+ fi
+ info "Triggering watchdog"
+ : > /dev/watchdog
+else
+ modprobe ib700wdt
+ modprobe i6300esb
+fi